% eegplugin_thinkgear() - EEGLAB plugin for importing Brainvision 
%                         .vhdr data files.
%
% Usage:
%   >> eegplugin_thinkgear(fig, trystrs, catchstrs);
%
% Inputs:
%   fig        - [integer]  EEGLAB figure
%   trystrs    - [struct] "try" strings for menu callbacks.
%   catchstrs  - [struct] "catch" strings for menu callbacks.
%

% Copyright (c) 2008-2009 NeuroSky, Inc. All Rights Reserved

function vers = eegplugin_thinkgear(fig, trystrs, catchstrs)

    vers = 'thinkgear';
    if nargin < 3
        error('eegplugin_thinkgear requires 3 arguments');
    end;
    
    % add folder to path
    % ------------------
    if ~exist('eegplugin_thinkgear')
        p = which('eegplugin_thinkgear.m');
        p = p(1:findstr(p,'eegplugin_thinkgear.m')-1);
        addpath( p );
    end;
    
    % find import data menu
    % ---------------------
    comcnt1 = [ trystrs.no_check '[EEG tmp LASTCOM] = pop_loadthinkgear;' catchstrs.new_non_empty ];
    comcnt2 = [ trystrs.no_check '[EEG        ] = pop_loadstreamlogfile;' catchstrs.new_non_empty ];
                 
    % create menus
    % ------------
    menui = findobj(fig, 'tag', 'import data');
    uimenu( menui, 'label', 'From Neurosky thinkgear file',  'callback', comcnt1, 'separator', 'on' );
    uimenu( menui, 'label', 'From Neurosky streamlog file',  'callback', comcnt2 );
    
