function this = datarowdecoder(varargin);

    if nargin < 1, opt = struct([]); else opt = varargin{1}; end;
    if ~isstruct(opt), opt = struct(varargin{:}); end;
    
    if ~isfield(opt, 'firmware'),           opt(1).firmware = '1.5'; end;
    if ~isfield(opt, 'firmwarecorrect'),    opt.firmwarecorrect = 4979; end;
    if ~isfield(opt, 'srate'),              opt.srate = []; end;
    if ~isfield(opt, 'bitlevels'),          opt.bitlevels = 1024; end;
    if ~isfield(opt, 'instancename'),       opt.instancename = ''; end;
    if ~isfield(opt, 'nskvar'),             opt.nskvar = 'nsk'; end;
    if ~isfield(opt, 'parsedpacketsvar'),   opt.parsedpacketsvar = 'parsedpackets'; end;
    if ~isfield(opt, 'decodevolt'),         opt.decodevolt = 'on'; end;
    if ~isfield(opt, 'gettimeinfo'),        opt.gettimeinfo = 'off'; end;    
    
    this.firmware           = opt.firmware; %1.5;
    this.firmwarecorrect    = opt.firmwarecorrect; %4979;
    this.instancename       = opt.instancename;
    this.srate              = opt.srate;
    this.bitlevels          = opt.bitlevels;
    this.nbchan             = 0; % private variable
    this.parsedpacketsvar   = opt.parsedpacketsvar;
    this.gettimeinfo        = opt.gettimeinfo;
    this.nskvar             = opt.nskvar;
    this.packetpos          = 1;
    this.tmpsratetime       = [];    
    this.tmpsratecount      = [];
    this.decodecommand      = '';
    this.decodevolt         = opt.decodevolt;
    this.timelastpacket     = zeros(1, 100);
    this.datacodes          = [ 4 13:18 19:25 ];
    this.warningshown       = 0;

    this = class(this, 'datarowdecoder');
    this = flush_buffer(this);
    