function [this] = packetdecoder_process( this, varargin );

if this.nbchan == 0
    this.timelastpacket(:) = toc;
    pause(0.1);
end;

% packet variable set up?
% -----------------------
eval([ 'global ' this.parsedpacketsvar ' ' this.nskvar ';' ...
       'empt = isempty(' this.parsedpacketsvar ');' ]);
if empt, return; end;
eval([ 'packetpointer = ' this.parsedpacketsvar '.pointer;' ...
       'packetlen     = length(' this.parsedpacketsvar '.data);' ]);
if this.packetpos == packetpointer, return; end;

% get the new packets
% -------------------
if this.packetpos < packetpointer
     eval( [ 'tmpparsedpackets = '   this.parsedpacketsvar '.data(this.packetpos:'      this.parsedpacketsvar '.pointer-1);' ]);
else eval( [ 'tmpparsedpackets = [ ' this.parsedpacketsvar '.data(this.packetpos:end) ' this.parsedpacketsvar '.data(1:' this.parsedpacketsvar '.pointer-1) ];' ]);
end;
this.packetpos = packetpointer;

% get sampling rate
% -----------------
% if isempty(this.srate)
%     this.tmpsratetime  = [ this.tmpsratetime toc ];
%     this.tmpsratecount = [ this.tmpsratecount length(tmpparsedpackets) ];
%     
%     if length(this.tmpsratetime) == 10
%         tmpsrate = (this.tmpsratetime(6:end)-this.tmpsratetime(5:end-1))./this.tmpsratecount(6:end);
%         tmpsrate = 1./tmpsrate
%         this.srate = round(mean(tmpsrate));
%         classicalsr = [128 512 ]; % classical sampling rates
%         [ tmp ind ] = min(abs(this.srate - classicalsr));
%         this.srate  = classicalsr(ind);
%         %fprintf('Sampling rate is %3.2f Hz, bitlevel is %d, number of channel is %d\n', this.srate, this.bitlevels, this.nbchan);
%         fprintf('Sampling rate is %3.2f Hz\n', this.srate);
%     else
%         return;
%     end;
%     
%     % set bitlevel
%     if this.srate == 512
%          this.bitlevels = 4096; % ASIC
%     else this.bitlevels = 1024; % Mindset-pro
%     end;
% end;

    % decode packets
    % --------------
    DATAROW_GETCODES;
    TG_GETCODES;
    alltgbytes         = [ TG_CODES{:,2} ];
    alltggetpos        = [ TG_CODES{:,3} ];
    datarowintcodes    = [ DATAROW_CODES{:,2} ];
    datarowcorresp     = zeros(1, max(datarowintcodes));
    datarowcorresp(datarowintcodes) = [1:length(datarowintcodes)];

    buffer      = zeros(size(TG_CODES,1),length(tmpparsedpackets), 'single');
    buffercount = zeros(1,size(TG_CODES,1));
    
    for ip = 1:length(tmpparsedpackets)
        
        payloadBuffer = tmpparsedpackets{ip};
        %if payloadBuffer(1) == 144, this.params.srate = 256; end;
        
        ind       = datarowcorresp(payloadBuffer(1));
        tgcodes   = DATAROW_CODES{ind,3};  % get the TG codes (thinkgear) correspoding to the Datarow value
        tgbytes   = alltgbytes(tgcodes+1); % get the bytes for the different packets in the Datarow (DATA(2) TIMESTAMP(1) DATA(2) TIMESTAMP(1) ...)
        
        if this.warningshown == 0 && isempty(tgcodes)
            this.warningshown = 1;
            fprintf('\nWarning: Datarow code %d (and maybe others) detected but not decoded\n\n', payloadBuffer(1));
        end;
        
        if ~isempty(tgcodes)
            if length(tgcodes) > 1 || tgbytes(1) > 1
                count   = 3;
                counttg = 1;
                while count <= length( payloadBuffer )
                    curind = tgcodes(counttg)+1;
                    if tgbytes(counttg) == 1
                        % decode 1-byte codes in sequence
                        buffercount(curind)                = buffercount(curind)+1;
                        buffer(curind,buffercount(curind)) = payloadBuffer(count);
                        count = count+1;
                    elseif tgbytes(counttg) == 2
                        % decode 2-byte codes in sequence
                        if payloadBuffer(1) == 176, % special case B0 
                            fithbiton = (bitand(payloadBuffer(count), 16) > 0)+0;
                            intval = bitand( payloadBuffer(count), 15)*256 + payloadBuffer(count+1) - fithbiton;
                        else
                            intval = payloadBuffer(count)*256+payloadBuffer(count+1);
                        end;
                        %if buffercount(curind) == 64, sfddsaf; end;
                        if intval > 32767, intval = intval-65536; end
                        buffercount(curind)                = buffercount(curind)+1;
                        buffer(curind,buffercount(curind)) = intval;
                        count = count+2;
                    else
                        hexstr = sprintf('%.2X%.2X%.2X%.2X', payloadBuffer(count+3), payloadBuffer(count+2), ...
                                       payloadBuffer(count+1), payloadBuffer(count));
                        buffercount(curind)                = buffercount(curind)+1;
                        buffer(curind,buffercount(curind)) = hex2float(hexstr);
                        count = count+4;
                    end;
                    counttg = counttg+1;
                end;
            else
                % decode 1-byte codes
                buffercount(tgcodes+1)                   = buffercount(tgcodes+1)+1;
                buffer(tgcodes+1,buffercount(tgcodes+1)) = payloadBuffer(2);
            end;
        end;
    end;    
    
% Flashes are not processed
% -------------------------
%             case { 241 242 243 244 } % no TG values for this
%                 ledind = payloadBuffer(1)-240;
%                 eval([this.nskvar '.flash(ledind).timevalues(' this.nskvar '.flash(ledind).count) = payloadBuffer(2);' ...
%                       this.nskvar '.flash(ledind).datacount( ' this.nskvar '.flash(ledind).count) = ' this.nskvar '.data.count-1+buffercount(5);' ...
%                       this.nskvar '.flash(ledind).count    = ' this.nskvar '.flash(ledind).count+1;' ]);
%catch,
%    command = [];[
%    fprintf('Packet corrupted (packet length %d): %s\n', length(tmpparsedpackets{ip}), lasterr)
%end;

    % decode all data values at once
    % ------------------------------
    if any(buffercount)
        if strcmpi(this.gettimeinfo, 'on'), tmptime = toc; end;
        
        % initialize commands
        if this.nbchan == 0
            this.nbchan = max(find(buffercount([ 4 13:18 ]+1)));
            this.datacodes = this.datacodes(find(buffercount(this.datacodes+1))); % remove datacodes
            this.datacodes = this.datacodes(:)';
            this = buildcommandscript(this, buffercount);
        end;
        
        % deal with all other fields
        v = find(buffercount);
        for ind = 1:length(v)
            fi = v(ind);
            fs = TG_CODES{fi,4};
            fc = buffercount(fi);
    
            commanddata = [ this.nskvar '.' fs '.values(tmpcount:tmpcount+fc-1) = double(buffer(fi,1:fc));' ];
            commanddata2 = '';
            if any(TG_CODES{fi,1} == [4 13:18]) && strcmpi(this.decodevolt, 'on')
                commanddata2 = [ this.nskvar '.' fs '.voltvalues(tmpcount:tmpcount+fc-1) = feval(' this.nskvar '.params.decodecommand,double(buffer(fi,1:fc)));' ];
            end;
            
            if TG_CODES{fi,3} && strcmpi(this.gettimeinfo, 'on')
                timearray  = linspace(0, tmptime-this.timelastpacket(fi), fc+1); timearray(1) = [];
                this.timelastpacket(fi) = tmptime;
                
                eval([  'if ~isfield(' this.nskvar ',''' fs '''),' this.nskvar '= init_nsk(' this.nskvar ',''createtgfield'',' int2str(fi) ', ''timeinfo'', TG_CODES{fi,3}); end;' ...
                        'tmpcount = ' this.nskvar '.' fs '.count;' ...
                        'if tmpcount > 1, prevtime = ' this.nskvar '.' fs '.time(tmpcount-1);' ...
                        'else             prevtime = this.timelastpacket(fi); end;' ...
                        this.nskvar '.' fs '.time(  tmpcount:tmpcount+fc-1) = prevtime+timearray;' ...
                        commanddata ...
                        commanddata2 ...
                        this.nskvar '.' fs '.count =' this.nskvar '.' fs '.count  + fc;' ]);
            else
                eval([ 'if ~isfield(' this.nskvar ',''' fs '''),' this.nskvar '= init_nsk(' this.nskvar ',''createtgfield'',' int2str(fi) '); end;' ...
                        'tmpcount = ' this.nskvar '.' fs '.count;' ...
                        commanddata ...
                        commanddata2 ...
                        this.nskvar '.' fs '.count =' this.nskvar '.' fs '.count  + fc;' ]);
            end;
        end;        
    end;
    
% --------------------------------------------------------------
% 4-byte hex to float conversion
% (standard Matlab only allows 8-byte double)
% adapted from Excel file "ieeefloats.xls" found on the internet
% --------------------------------------------------------------
% called using: power.values(power.count,count) = hex2float(hexstr)
function f = hex2float(hexstr)

    num = uint32(hex2dec(hexstr));

    sign = fastif(bitget(num,32), -1, 1);

    expo  = num;
    for i=[1:23 32], expo = bitset(expo, i, 0); end;
    expo  = double(bitshift(expo, -23))-127;

    val  = num;
    for i=24:32, val = bitset(val, i, 0); end;
    val = 1+double(val)/8388608;

    f = double(sign)*val*2^double(expo);      
return;
