% Read from byte stream defined in FILESTREAM

% Copyright (c) 2008-2009 NeuroSky, Inc. All Rights Reserved

function this = filestream_process( this )
    
    persistent A; % avoid rereserving array every time

    streambuffervar = this.streambuffervar;
    eval(['global ' streambuffervar ]);
    
    % test is file open
    % -----------------
    if isempty( this.fileid_replay ), return; end;
    
    % initialize variable
    % -------------------
    eval( [ 'empt = isempty(' streambuffervar ');' ]);
    if empt
        if ~isnumeric(this.fileid_replay) | length(this.fileid_replay) == 1
            eval([ streambuffervar '.data    = single(zeros(1,' num2str(this.filebytesize) '));' ]);
        else
            eval([ streambuffervar '.data    = this.fileid_replay;' ]);
        end;
        eval([ streambuffervar '.pointer = 1;' ]);
        eval([ streambuffervar '.params = this.headsetinfo.params;' ]);
    end;
    
    % initialize peristent variable
    % -----------------------------
    if isempty(A), 
        A = zeros(this.filebytesize, 1);
    end;
    
    % how many bytes to read (smooth scrolling)
    % -----------------------------------------
    if strcmpi(this.filepos, 'continuous')
        bytestoread = this.bytespersecond;
    else
        bytestoread = this.filepos;
    end;
    
    count = 1;
    eval([ 'localpointer = ' streambuffervar '.pointer;' ]);
    eval([ 'datalen      = length(' streambuffervar '.data);' ]);
    if ~isnumeric(this.fileid_replay) || length(this.fileid_replay) == 1
        while count < bytestoread && ~feof(this.fileid_replay)
            % read one line from streamlog file and decode it
            % -----------------------------------------------
            tmpline   = fgetl( this.fileid_replay );
            if isempty(tmpline), tmpline   = fgetl( this.fileid_replay ); end;

            tmpind    = find(tmpline == ':');
            if isempty(tmpind), tmpind = 0; end;
            tmpbuffer = tmpline(tmpind+1:end);
            inds      = find(tmpbuffer == ' ');
            %inds      = inds-tmpind;
            if length(inds) > 1
                if inds(1) == 1 && inds(2) == 2, inds(1) = []; end;
            end;
            if inds(end) == length(tmpbuffer), inds(end) = []; end;

            % copy data to buffer
            % -------------------
            for i = 1:length(inds)
                A(count) = myhex2dec(tmpbuffer(inds(i)+1:inds(i)+2));
                count = count+1;
            end;
        end;

        % test for end of file
        % --------------------
        if feof(this.fileid_replay), 
            fclose(this.fileid_replay);
            this.fileid_replay = []; 
        end;
        
        % place the data in the buffer
        if length(A) > datalen
            eval( [ streambuffervar '.data = A;' ]);
            eval( [ streambuffervar '.pointer = length(A)+1;' ]);
        else
            lenA = count-1;
            if localpointer+lenA-1 > datalen
                % end of buffer reached, copy at the beginning
                inds1forBuffer = [localpointer:datalen];
                inds2forBuffer = [1:lenA-length(inds1forBuffer)];
                inds1forA      = [1:length(inds1forBuffer)];
                inds2forA      = [length(inds1forBuffer)+1:lenA];
                eval([ streambuffervar '.data(inds1forBuffer) = A(inds1forA);' ]);
                eval([ streambuffervar '.data(inds2forBuffer) = A(inds2forA);' ]);
                eval([ streambuffervar '.pointer = length(inds2forBuffer)+1;' ]);
            else
                % middle of buffer
                indsforbuffer = [localpointer:localpointer+lenA-1];
                eval([ streambuffervar '.data(indsforbuffer) = A(1:lenA);' ]);
                eval([ streambuffervar '.pointer  = ' streambuffervar '.pointer + lenA;' ]);
            end;
        end;
        
    elseif ~isempty(this.fileid_replay);
        localpointer = localpointer + bytestoread;
        if localpointer > datalen
            eval([ streambuffervar '.pointer = datalen+1;' ]);
            this.fileid_replay = [];
        else
            eval([ streambuffervar '.pointer = localpointer;' ]);
        end;
    end;
    
% --------------------------------------------------------------
% 4-byte hex to float conversion
% (standard Matlab only allows 8-byte double)
% adapted from Excell file "ieeefloats.xls" found on the internet
% --------------------------------------------------------------
% called using: power.values(power.count,count) = hex2float(hexstr)
function f = hex2float(hexstr)

    num = uint32(hex2dec(hexstr));

    sign = fastif(bitget(num,32), -1, 1);

    expo  = num;
    for i=[1:23 32], expo = bitset(expo, i, 0); end;
    expo  = double(bitshift(expo, -23))-127;

    val  = num;
    for i=24:32, val = bitset(val, i, 0); end;
    val = 1+double(val)/8388608;

    f = double(sign)*val*2^double(expo);    

function f = myhex2dec(hexstr)

    switch hexstr(2)
        case '0', f = 0;
        case '1', f = 1;
        case '2', f = 2;
        case '3', f = 3;
        case '4', f = 4;
        case '5', f = 5;
        case '6', f = 6;
        case '7', f = 7;
        case '8', f = 8;
        case '9', f = 9;
        case 'A', f = 10;
        case 'B', f = 11;
        case 'C', f = 12;
        case 'D', f = 13;
        case 'E', f = 14;
        case 'F', f = 15;
    end;
    switch hexstr(1)
        case '1', f = f+16;
        case '2', f = f+32;
        case '3', f = f+48;
        case '4', f = f+64;
        case '5', f = f+80;
        case '6', f = f+96;
        case '7', f = f+112;
        case '8', f = f+128;
        case '9', f = f+144;
        case 'A', f = f+160;
        case 'B', f = f+176;
        case 'C', f = f+192;
        case 'D', f = f+208;
        case 'E', f = f+224;
        case 'F', f = f+240;
    end;
    