function this = replay(this, filename);

    if isempty(filename)
        [filename filepath] = uigetfile('*.txt', 'Pick a Streamlog file');
        if filename(1) == 0, return; end;
        filename = fullfile(filepath, filename);
        
        this.headsetinfo = getguiinfo(this.headsetinfo);
    end;
        
    if ~isempty(this.fileid_replay), fclose( this.fileid_replay ); this.fileid_replay = []; end;
        
    try,
        tmpdata = load('-mat', filename);
        if ~isfield(tmpdata, this.matlabfilefield)
            warndlg('Field not found in Matlab file', 'Warning', 'modal');
        else
            disp( [ 'Getting data from field ''' this.matlabfilefield ''' of file ' filename ]);
            this.fileid_replay = getfield(tmpdata, this.matlabfilefield);
            this.fileid_replay = this.fileid_replay(:)';
        end;
    catch,
        this.filebytesize  = dir(filename);
        if isempty(this.filebytesize), error('File not found'); end;
        this.filebytesize  = this.filebytesize.bytes;
        this.fileid_replay = fopen(filename, 'r');
        if this.fileid_replay == -1
            warndlg('Cannot open file', 'Warning', 'modal');
            this.fileid_replay = [];
        end;
    end;