% GETGUIINFO graphic interface pop up window to select which headset is 
%            being used.
%
% serialportobj = GETGUIINFO(headsetinfo, port)
%
% headsetinfo   - object created using the headsetinfo
%                 function. The object is updated as a result of 
%                 connection.
% port          - may be 'gui' to pop up a graphic interface or
%                 a port name ('COM1' for instance).

% Copyright (c) 2008-2009 NeuroSky, Inc. All Rights Reserved

function this = getguiinfo(this, portname);

    if strcmpi(this.port, 'gui')
% connect to chipset (latest interface)
% -------------------------------------
%     textport = { 'Auto-detect (long delay)' };
%     for i=1:64
%         textport{i+1} = [ 'COM' int2str(i) ];
%     end;
%     cb_txt = [ 'tmpconf = get(findobj(sfig, ''tag'', ''firmware''), ''value'');' ...
%                'tmpval  = get(findobj(sfig, ''tag'', ''options'') , ''value'');' ...
%                'tmpuser = get(sfig, ''userdata'');' ...
%                'tmpuser = tmpuser(tmpconf);' ...
%                'tmpfields = fieldnames(tmpuser);' ...
%                'tmptxt    = '''';' ...
%                'for tmpind = 3:length(tmpfields),' ...
%                '   if length(getfield(tmpuser, tmpfields{tmpind})) >= tmpval,' ...
%                '       tmpstr = getfield(tmpuser, tmpfields{tmpind}, { tmpval });' ...
%                '       tmptxt = strvcat(tmptxt, num2str(tmpstr));' ...
%                '   end;' ...
%                'end;' ...
%                'set(findobj(sfig, ''tag'', ''textout''), ''string'', tmptxt);' ...
%                'clear tmptxt tmpfields tmpuser tmpval tmpconf;' ];
%     cb_options = [ 'tmpconf = get(gcbo, ''value'');' ...
%                    'tmpuser = get(gcbf, ''userdata'');' ...
%                    'set(findobj(gcbf, ''tag'', ''options'') , ''string'', tmpuser(tmpconf).thinkgear, ''value'', 1);' ...
%                    'clear tmpconf tmpuser;' ];
%     tmptxt = cell(1,8);
%     tmptxt(:) = { 'xxxxxxxx' };
%     tmptxt = strvcat(tmptxt);
%     tmptxtlab = getformatedfields(this.allformats);
%     tmptxtlab(1:2) = []; 
%     tmptxtlab = strvcat(tmptxtlab);
%     
%     uilist = { { 'Style' 'text' 'string' 'Select configuration' 'fontweight' 'bold'} ...
%                { 'Style' 'popupmenu' 'string' { this.allformats.headset } 'tag' 'firmware' 'callback' [cb_options 'sfig = gcbf;' cb_txt] } ...
%                {} ...
%                { 'Style' 'text' 'string' 'Select options' 'fontweight' 'bold'} ...
%                { 'Style' 'popupmenu' 'string' this.allformats(1).thinkgear 'tag' 'options' 'callback' ['sfig = gcbf;' cb_txt] } ...
%                {} ...
%                { 'Style' 'text'      'string' 'Description' 'fontweight' 'bold'} ...
%                { 'Style' 'text'      'string' tmptxtlab } ...
%                { 'Style' 'text'      'string' tmptxt 'tag' 'textout' } ...
%                {} ...
%                { 'Style' 'text' 'string' 'Select port' 'fontweight' 'bold' } ...
%                { 'style' 'listbox'  'string' textport 'tag' 'port' } };
% 
%     inputgui( 'geometry', {1 1 1  1 1 1  1 [1.5 1] 1  1 1}, 'uilist', uilist, 'geomvert', [1 1 0.5 1 1 0.5 1 6 0.5 1 5], ...
%         'mode', 'plot', 'userdata', this.allformats );
%     hgsave(gcf, 'connectcomplex2.fig', '-v6');
%     close;
%     
% connect to chipset (simplified version)
% ---------------------------------------
% pop-up window to detect communication port
%             textport = { 'Auto-detect (long delay)' };
%             for i=1:64
%                 textport{i+1} = [ 'COM' int2str(i) ];
%             end;
% %             uilist = { { 'Style' 'text' 'string' 'Select board' 'fontweight' 'bold'} ...
% %                        { 'Style' 'popupmenu' 'string' { 'default' '1.79' '1.7' '1.5A' 'FPGA - board' 'FPGA - headset' } 'tag' 'firmware' } ...
% %                        {} ...
% %                        { 'Style' 'text' 'string' 'Select port' 'fontweight' 'bold' } ...
% %                        { 'style' 'listbox'  'string' textport 'tag' 'port' } };
% %             inputgui( 'geometry', {1 1 1 1 1}, 'uilist', uilist, 'geomvert', [1 1 0.5 1 5], 'mode', 'plot');
% 
% connect to chipset (more complex version)
% -----------------------------------------
%         cb_srate = [ 'if get(gcbo,''value'')==4 , set(findobj(gcbf, ''tag'', ''srateedit''), ''enable'', ''on'');' ...
%                      'else,                       set(findobj(gcbf, ''tag'', ''srateedit''), ''enable'', ''off''); end;' ];
%         cb_speed1 =[ 'if get(gcbo,''value'')==4 , set(findobj(gcbf, ''tag'', ''speededit1''), ''enable'', ''on'');' ...
%                      'else,                       set(findobj(gcbf, ''tag'', ''speededit1''), ''enable'', ''off''); end;' ];
%         cb_speed2 =[ 'if get(gcbo,''value'')==4 , set(findobj(gcbf, ''tag'', ''speededit2''), ''enable'', ''on'');' ...
%                      'else,                       set(findobj(gcbf, ''tag'', ''speededit2''), ''enable'', ''off''); end;' ];
%         uilist = { { 'Style' 'text' 'string' 'Select board' 'fontweight' 'bold'} ...
%                    { 'Style' 'popupmenu' 'string' { 'default' '1.79' '1.7' '1.5A' 'FPGA - board' 'FPGA - headset' } 'tag' 'firmware' } ...
%                    {} ...
%                    { 'Style' 'text'      'string' 'Sampling rate' 'fontweight' 'bold'} ...
%                    { 'Style' 'popupmenu' 'string' { 'auto' '128 Hz' '256 Hz' 'User defined' } 'tag' 'srate' 'callback' cb_srate } ...
%                    { 'Style' 'edit'      'string' '' 'enable' 'off' 'tag' 'srateedit' } ...
%                    {} ...
%                    { 'Style' 'text' 'string' 'Opening connection speed' 'fontweight' 'bold'} ...
%                    { 'Style' 'popupmenu' 'string' { 'Auto detect' '9600 bauds' '57600 bauds' 'User defined'  } 'tag' 'speed1' 'callback' cb_speed1 } ...
%                    { 'Style' 'edit'      'string' '' 'enable' 'off' 'tag' 'speededit1' } ...
%                    {} ...
%                    { 'Style' 'text' 'string' 'Streaming speed' 'fontweight' 'bold'} ...
%                    { 'Style' 'popupmenu' 'string' { 'Auto detect' '9600 bauds' '57600 bauds' 'User defined'  } 'tag' 'speed2' 'callback' cb_speed2 } ...
%                    { 'Style' 'edit'      'string' '' 'enable' 'off' 'tag' 'speededit2' } ...
%                    {} ...
%                    { 'Style' 'text' 'string' 'Commands to send' 'fontweight' 'bold'} ...
%                    { 'Style' 'edit' 'string' '' 'tag' 'commands' } ...
%                    {} ...
%                    { 'Style' 'text' 'string' 'Select port' 'fontweight' 'bold' } ...
%                    { 'style' 'listbox'  'string' textport 'tag' 'port' } };
%         inputgui( 'geometry', {1 1 1 1 [1 0.5] 1 1 [1 0.5] 1 1 [1 0.5] 1 1 1 1 1 1}, 'uilist', uilist, 'geomvert', [1 1 0.5 1 1 0.5 1 1 0.5 1 1 0.5 1 1 0.5 1 5], 'mode', 'plot');
%         hgsave(gcf, 'connect.fig', '-v6');
% final version
%             textport = { 'Auto-detect (long delay)' };
%             for i=1:64
%                 textport{i+1} = [ 'COM' int2str(i) ];
%             end;
%             uilist = { { 'Style' 'text' 'string' 'Select board' 'fontweight' 'bold'} ...
%                        { 'Style' 'popupmenu' 'string' { 'MindSet' 'ASIC/MindSet Pro' 'MindBuilder' 'FPGA - board' } 'tag' 'firmware' } {} ...
%                        { 'Style' 'text' 'string' 'Sampling rate' 'fontweight' 'bold'} ...
%                        { 'Style' 'popupmenu' 'string' { '128 Hz' '256 Hz' } 'tag' 'srate' } {} ...
%                        { 'Style' 'text' 'string' 'Connection speed' 'fontweight' 'bold'} ...
%                        { 'Style' 'popupmenu' 'string' { '9600 bauds' '57600 bauds' } 'tag' 'speed' } ...
%                        {} ...
%                        { 'Style' 'text' 'string' 'Select port' 'fontweight' 'bold' } ...
%                        { 'style' 'listbox'  'string' textport 'tag' 'port' } };
%             inputgui( 'geometry', {1 1 1 1 1 1 1 1 1 1 1}, 'uilist', uilist, 'geomvert', [1 1 0.5 1 1 0.5 1 1 0.5 1 7], 'mode', 'plot');
%             set(gcf, 'name', 'Connect');
%             hgsave(gcf, 'connect.fig', '-v6');
% simpliest version with PORT only            
%             textport = { 'Auto-detect (long delay)' };
%             for i=1:64
%                 textport{i+1} = [ 'COM' int2str(i) ];
%             end;
%             uilist = { { 'Style' 'text' 'string' 'Select port' 'fontweight' 'bold' } ...
%                        { 'style' 'listbox'  'string' textport 'tag' 'port' } };
%             inputgui( 'geometry', {1 1}, 'uilist', uilist, 'geomvert', [1 7], 'mode', 'plot');
%             set(gcf, 'name', 'Connect');
%             hgsave(gcf, 'connect_simple.fig', '-v6');

        % open figure and wait for user entry
        % -----------------------------------
        if strcmpi(this.connectinterface, 'simple')
             sfig = hgload('connect_simple.fig');
        else sfig = hgload('connectcomplex2.fig');
        end;

        allnames   = lower({ this.allformats.headset });
        headsetind = strmatch(lower(num2str(this.headset)), allnames);
        set(findobj(sfig, 'tag', 'firmware'), 'string', { this.allformats.headset }, 'value', headsetind);
        set(findobj(sfig, 'tag', 'options'), 'string', this.allformats(headsetind).thinkgear, 'value', this.headsetoption);
        set(sfig, 'userdata', this.allformats);
        cbtxt = get(findobj(sfig, 'tag', 'options'), 'callback');
        eval([ 'sfig =' num2str(sfig) ';' cbtxt(13:end) ]);
        recenter(sfig);

        % set port COM
        allports{1} = 'Auto';
        for index = 1:128
            allports{index+1} = [ 'COM' num2str(index) ];
        end;
        set(findobj(sfig, 'tag', 'port'), 'string', allports);
        
        waitfor( findobj('parent', sfig, 'tag', 'ok'), 'userdata');
        try findobj(sfig); catch return; end;

        % decode figure output
        % --------------------
        res = getguioutput(sfig); close(sfig);

        drawnow;

        % port number
        if res.port == 1, this.port = 'auto';
        else              this.port = [ 'COM' int2str(res.port-1) ];
        end;

        if ~isfield(res, 'firmware'), res.firmware = headsetind; res.options = this.headsetoption; end;
        this.headset       = this.allformats(res.firmware).headset;
        this.headsetoption = res.options;        
    end;
    
    if ~strcmpi(this.headset, 'custom')
        this.params = selectinfo( this.allformats, this.headset, this.headsetoption);
    end;
        