% check a single packet
% ---------------------
function [checksumres] = checkpacket(this, payloadBuffer )
    
    % read data into buffer
    % ---------------------
    rawchecksum = payloadBuffer(end);
    payloadSum = sum(payloadBuffer(4:end-1)); %payloadSum

    % read checksum
    % -------------
    checksum = dec2bin(rawchecksum);
    if length(checksum) > 8                 %if checksum is more than 8 bits, get the lower 8 bits
        checksum = checksum(length(checksum)-7:length(checksum));
    end
    checksum = bin2dec(checksum);
    checksum = 2^8 - 1 - checksum;          %compute checksum 1's inverse

    % compute data checksum
    % ---------------------
    payloadSum = dec2bin(payloadSum);
    if length(payloadSum) > 8               %if payloadsum is more than 8 bits, get the lower 8 bits
        payloadSum = payloadSum(length(payloadSum)-7:length(payloadSum));
    end
    payloadSum = bin2dec(payloadSum);

    checksumres = checksum == payloadSum;
