function this = packetparser(varargin);

    if nargin < 1, opt = struct([]);
    elseif isstruct(varargin{1}), opt = varargin{1};
    else
        opt = struct(varargin{:});
    end;
    
    % default parameter
    if ~isfield(opt, 'parsertype'),         opt(1).parsertype = 'normal'; end;
    if ~isfield(opt, 'streambuffervar'),    opt.streambuffervar = 'streambuffer'; end;
    if ~isfield(opt, 'parsedpacketsvar'),   opt.parsedpacketsvar = 'parsedpackets'; end;
    if ~isfield(opt, 'instancename'),       opt.instancename = ''; end;
    if ~isfield(opt, 'verbose'),            opt.verbose = 'off'; end;
    
    this.instancename       = opt.instancename;
        
    this.command          = 'reset';            
    this.filterbitstream  = [];        
    this.fileid_replay    = [];    
    this.parsepacketfunc  = @parsebyte;    
    this.streambuffervar  = opt.streambuffervar;
    this.parsedpacketsvar = opt.parsedpacketsvar;
    this.datapointer      = 1;
    this.automaton        = [];
    
    if strcmpi(opt.parsertype, 'FPGA')
        this.parsepacketfunc  = @parsebytefpga;  
    end;
    
	this.remain          = [];
    this.tmptime         = [];   
    this.commands        = [];
    
    if strcmpi(opt.verbose, 'on')
        disp('Packet parser options:');
        this
    end;
    
    this = class(this, 'packetparser');
