function [ this ] = dataparser_process( this, varargin );

    % pointer to the current position in streambuffer
    eval(['global ' this.streambuffervar ' ' this.parsedpacketsvar ]);
    
    eval( [ 'empt = isempty(' this.streambuffervar ');' ]);
    if empt, return; end;
    eval( [ 'currentstreampointer = ' this.streambuffervar '.pointer;' ...
            'currentstreamlen     = length(' this.streambuffervar '.data);' ...
            'params               = ' this.streambuffervar '.params;']);
    if this.datapointer == currentstreampointer, return; end;

    % switch to FPGA parser for FPGA board
    % ------------------------------------
    if isfield(params, 'thinkgear')
        if ~isempty(findstr('FPGA', params.thinkgear))
            this.parsepacketfunc =  @parsebytefpga;
        end;
    end;
    
    % variable initialization
    % -----------------------
    eval( [ 'empt = isempty(' this.parsedpacketsvar ');' ]);
    if empt
        eval( [ this.parsedpacketsvar '.data    = cell(1,2000);' ...
                this.parsedpacketsvar '.pointer = 1;' ...
                this.parsedpacketsvar '.params  = ' this.streambuffervar '.params;' ]);
    end;
    
    % get latest data indices
    % -----------------------
    if this.datapointer < currentstreampointer
        % end of buffer not reached
        inds = this.datapointer:currentstreampointer-1;
    else
        % end of buffer reached
        inds = [ this.datapointer:currentstreamlen 1:currentstreampointer-1 ];
    end;
    this.datapointer = currentstreampointer;
    
    % get the raw data
    eval( [ 'A = ' this.streambuffervar '.data(inds);' ...
            'pklen = length(' this.parsedpacketsvar '.data);' ] );
    
    % check size
    if round(length(A)/9) > pklen
        disp('Increasing buffer size for packets');
        eval( [ 'newbuff = cell(1,ceil(length(find(A == 170))));' ...
                'newbuff(1:' this.parsedpacketsvar '.pointer) = '  this.parsedpacketsvar '.data(1:' this.parsedpacketsvar '.pointer);' ...
                'newbuff(end-pklen+' this.parsedpacketsvar '.pointer:end) = '  this.parsedpacketsvar '.data(' this.parsedpacketsvar '.pointer:end);' ...
                this.parsedpacketsvar '.data    = newbuff;' ]);
    end;
    
    % parse and store packets
    parsedpacketstmp = {};
    for indexa = 1:length(A)
        % parse single bits
        [this res payload] = feval(this.parsepacketfunc, this, A(indexa));
        
        if res == 1
            %if count == 10, error('test'); end; count = count+1;
            % parse the payload
            parsedpacketstmp2 = parse_payload(this, payload);
            parsedpacketstmp(end+1:end+length(parsedpacketstmp2)) = parsedpacketstmp2;
        end
    end;
    
    % store the parsed payload
    eval( [ ...
        'for i = 1:length(parsedpacketstmp),' ...
              this.parsedpacketsvar '.data{ ' this.parsedpacketsvar '.pointer } = parsedpacketstmp{i};' ...
              'if ' this.parsedpacketsvar '.pointer < length(' this.parsedpacketsvar '.data),' ...
                    this.parsedpacketsvar '.pointer = ' this.parsedpacketsvar '.pointer + 1;' ...
              'else,' ...
                    this.parsedpacketsvar '.pointer = 1;' ...
              'end;' ...
        'end;' ]);
    %fprintf('len A %d (%d packets)\n', length(A), parsedpackets.pointer-npack);

    