            % Field name           Code    Corresponding TG_CODE(s)

DATAROW_CODES = { ...
            'BATTERY',             01      [0]; % value: 0 to 127 
            'POOR_QUALITY',        02      [1]; % value: 0 to 255 
            ...
            'ATTENTION',           04      [2]; % value: 0 to 100 
            'MEDITATION',          05      [3]; % value: 0 to 100 
            '8BITRAW_SIGNAL',      06      [4]; % value: 0 to 255 
            'RAW_MARKER',          07      [5]; % value: 0 
            'OFFHEAD_VALUE',       08      [6]; % value: 0 to 64 
            'FLAT',                09      [7]; % value: ? 
            'EXCESS',              10      [8]; % value: ? 
            'LOWPOWER',            11      [9]; % value: ? 
            'HIGHPOWER',           12      [10]; % value: ? 
            'ERRFLAGS',            13      [11]; % value: error bits set 
            'ZONE',                14      [38];
            'EEPROM_MODE_NOTICE',  15      []; % value: F2 
            'EEPROM_DUMP_BEGIN',   16      []; % value: 0 to 255 
            'EEPROM_OK',           17      []; % value: cksum 
            'EEPROM_ERROR',        18      []; % value: error cksum 
            ...
            'DAMPENED_ATTENTION',  20      [31]; % value: 1 to 10 
            'DAMPENED_MEDITATION', 21      [32]; % value: 1 to 10 
            'BLINK_STRENGTH',      22      [37];
            ...
            'EVENT',               30      [36];
            ...
            'EXCODE',              55      []; % value: N/A 
            ...
            'TRANSMITTER_ID',      127     [33]; 
            'RAW_SIGNAL',          128     [4]; % value: -32768 to 32767 
            'EEG_POWERS',          129     [5:12]; % value: float (x8) 
            'ASIC_FFT',            130     [];     % value: -32768 to 32767 (x2) 
            'ASIC_EEG_POWER_INT',  131     [5:12]; % value: -8388608 to 8388607 (x8) 
            ...
            'ESENSE_DETAILS',      133     []; % value: ? 
            'OFFHEAD_POINTS',      134     []; % value: ? 
            'CONFIGURATION',       135     []; % value: ? 
            ...
            'ASIC_SLOPE_FILTER',   143     []; % value: ? 
            'RAW2_SIGNAL',         144     [4 19 13 20 14 21 15 22 16 23 17 24 18 25]; % value: ? (xN) 
            'ACCELEROMETER_RAW',   145     [26 27 28]; % value: ? (xN) 
            'TEMPERATURE_RAW',     146     [29]; % value: ? (xN) 
            'GSR_RAW',             147     [30]; % value: ? (xN) 
            ...
            'SEP',                 160     [34 35]; % value: ? (xN) 
            ...
            'SYNC',                170     []; % value: N/A 
            'RAW_SIGNALN',         176     [4 13 14 15 16 17 18]; % value: N/A 
            ...
            'OFFHEAD',             192     [39 40 41]; % value: N/A 
            ...
            'EEPROM_READ_OUTPUT',  237     []; % value: 0 to 255 (xN) 

            'ASIC_FFT_0',          241     []; % value: -32768 to 32767 (x2) 
            'VERSION',             242     []; % value: 0 to 255 (x4) 
            'FLASH1',              243     []; % value: 0 to 255 (x4) 
            'FLASH2',              244     []; % value: 0 to 255 (x4) 
            'FLASH3',              245     []; % value: 0 to 255 (x4) 
            'FLASH4',              246     []; % value: 0 to 255 (x4) 
            };