function [nsk ] = init_nsk(nsk, varargin);

    opt = struct(varargin{:});
    if ~isfield(opt, 'srate'),   opt.srate   = 512; end;
    if ~isfield(opt, 'nbchan'),  opt.nbchan  = 1; end;
    if ~isfield(opt, 'createtgfield'),  opt.createtgfield = []; end; % index of tgfield
    if ~isfield(opt, 'fieldname'),  opt.fieldname = ''; end; 
    if ~isfield(opt, 'timeinfo'),  opt.timeinfo = 0; end;
    if ~isfield(opt, 'tgrates'), opt.tgrates = ones(1,50); opt.tgrates(4) = opt.srate; end;

    % which fields to create
    if ~isempty(opt.createtgfield)
         indfield = opt.createtgfield;
    else indfield = find(opt.tgrates);
    end;
    
    TG_GETCODES;
    minfreq = min(opt.tgrates);
    for fi = 1:length(indfield)
        points = round(1200 + round(rand(1)*20)); % 20 minutes=1200 seconds, random ensure that not all fields will be updated at the same time
        if ~isempty(opt.fieldname) || opt.tgrates(indfield(fi)) > minfreq+2, 
            points = opt.srate*points;
        end;
        if isempty(opt.fieldname)
            nsk = setfield(nsk, TG_CODES{indfield(fi),4}, 'values', zeros(opt.nbchan,points));
            if opt.timeinfo && TG_CODES{indfield(fi),3}
                nsk = setfield(nsk, TG_CODES{indfield(fi),4}, 'time', zeros(opt.nbchan,points));
            end;
            if length(TG_CODES{indfield(fi),4}) > 2 && strcmpi(TG_CODES{indfield(fi),4}(1:3), 'EEG')
                nsk = setfield(nsk, TG_CODES{indfield(fi),4}, 'voltvalues', zeros(opt.nbchan,points));
            end;
            nsk = setfield(nsk, TG_CODES{indfield(fi),4}, 'count', 1);
        else
            nsk = setfield(nsk, opt.fieldname, 'values', zeros(opt.nbchan,points));
            nsk = setfield(nsk, opt.fieldname, 'count', 1);
        end;
    end;
   